#!/bin/sh
CONFCLIENT=/usr/sbin/confclient

path=`readlink -f "$0"`
path=$(dirname "${path}")
VADP_INDEX=`echo "${path}" | awk -F"/" '{print $(NF-1)}'`
VADP_PATH=`${CONFCLIENT} -p 99 -g vadp_module_i${VADP_INDEX}_path -t Value`

echo -ne "Content-type:text/plain\r\n"
echo -ne "\r\n" # end of HTTP header 


if [ $REQUEST_METHOD = POST ]; then
	strparam=`cat $stdin | cut -c1-$CONTENT_LENGTH`
else
	strparam=$QUERY_STRING
fi

GET_NTP_PATH="${VADP_PATH}/script/GetNTPServer"
REGISTER_PATH="${VADP_PATH}/script/RegisterDevice"
GET_SSH_PATH="${VADP_PATH}/script/GetSSHServer"
CONNECT_PATH="${VADP_PATH}/script/ConnectSSH"
GET_CONNECT_PATH="${VADP_PATH}/script/GetConnectInfo"
ACTIVE_STATUS_PATH="/mnt/flash2/unifs/etc/conf.d/ActiveStatus"
STRATOCAST_COMMON_PATH="${VADP_PATH}/script/StratocastCommon"
. $STRATOCAST_COMMON_PATH

retry_time=0
$GET_NTP_PATH ${VADP_PATH} >> /dev/null
result=$?
while [ "$result" != "0" ]
do
	if [ "$retry_time" == "5" ]; then
		echo -ne "Error occurs when getting NTP server"	
		# status page
	fi

	retry_time=$(($retry_time+1))
	echo -ne "\r\n\r\n $DATE [Stratocast] Get NTP server failed ($retry_time)" >> ${LOGFILE_PATH}
	
	sleep 30	
	$GET_NTP_PATH ${VADP_PATH} >> /dev/null
	result=$?	
done

retry_time=0
logger -t "[Stratocast]" "Register Device"
$REGISTER_PATH $strparam ${VADP_PATH} >> /dev/null
result=$?
while [ "$result" != "0" ]
do
	if [ "$result" == "1" ]; then
		#401
		logger -t "[Stratocast]" "Invalid Device Authentication Code or the camera is already registered"
		echo -ne "Invalid Device Authentication Code or the Camera is Already Registered"
		echo -ne "\r\n\r\n $DATE [Stratocast] Invalid Device Authentication Code or the camera is already registered" >> ${LOGFILE_PATH}
		exit 1
		# status page
	fi
	
	if [ "$result" == "3" ]; then
		#403
		logger -t "[Stratocast]" "Device is not allowed into the system"
		echo -ne "Device is not allowed into the system"
		echo -ne "\r\n\r\n $DATE [Stratocast] Device is not allowed into the system" >> ${LOGFILE_PATH}
		exit 1
	fi

	if [ "$result" == "4" ]; then
		#404
		logger -t "[Stratocast]" "Register is called before \"Generate Activation Code\""
		echo -ne "Register is called before \"Generate Activation Code\""
		echo -ne "\r\n\r\n $DATE [Stratocast] Register is called before \"Generate Activation Code\"" >> ${LOGFILE_PATH}
		exit 1
	fi
	
	retry_time=$(($retry_time+1))
	echo -ne "\r\n\r\n $DATE [Stratocast] Registering failed ($retry_time)" >> ${LOGFILE_PATH}
	
	sleep 30
	$REGISTER_PATH $strparam ${VADP_PATH} >> /dev/null
	result=$?
done

retry_time=0
$GET_SSH_PATH ${VADP_PATH} >> /dev/null
result=$?
while [ "$result" != "0" ]
do
	retry_time=$(($retry_time+1))
	
	$GET_CONNECT_PATH ${VADP_PATH} >> /dev/null
	if [ "$?" == "4" ]; then
		echo -ne "\r\n\r\n $DATE [Stratocast] The camera is already unregistered" >> ${LOGFILE_PATH}
		echo -ne "The camera is already unregistered"
		logger -t "[Stratocast]" "The camera is already unregistered"
		exit 1
	fi
	
	echo -ne "\r\n\r\n $DATE [Stratocast] Get SSH information failed ($retry_time)" >> ${LOGFILE_PATH}
	sleep 30
	$GET_SSH_PATH ${VADP_PATH} >> /dev/null
	result=$?
done

$CONNECT_PATH ${VADP_PATH} >> /dev/null
logger -t "[Stratocast]" "Successfully Register Device"

echo -ne "Activated"
